module KintoneNotifier
  class Bot

    def initialize(options={})
      raise ArgumentError, "invalid argument. class configuration haven't been given." if @@config.blank?
      @options = default_options.reverse_merge(default_options)
      @api =  Kintone::Api.new(@options["url"],@options["user"],@options["password"])
    end
    def tweet(values={})
      @api.record.create(@options["app_id"],convert_hash(values.reverse_merge(default_values)))
    end

    def self.config=(h)
      @@config = h
    end

    private
    def convert_hash(h)
      val = {}.tap do |_val|
        h.each do |k,v|
          _val.merge!(k => {"value" => v})
        end
      end
    end

    def default_options
      @@config.stringify_keys
    end

    def default_values
      {
        "app_name"        => app_name,
        "server"          =>  Socket.gethostname ,
        "rails_root"      =>  Rails.root,
        "svn_version"     =>   %x[ svnversion ],
        "pid"             =>  $$
      }
    end

    def app_name
      if Rails.respond_to?(:application)
        Rails.application.class.name.split("::").shift
      else
        Rails.root.to_s.split("/")[-2]
      end
    end
  end
end